GNU bug report logs - #44100
26.3; ERC: Make IBuffer custom display work again

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Olivier Certner <ocert.dev@HIDDEN>; Keywords: patch; dated Tue, 20 Oct 2020 16:49:01 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 44100 <at> debbugs.gnu.org:


Received: (at 44100) by debbugs.gnu.org; 1 Nov 2020 13:10:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Nov 01 08:10:09 2020
Received: from localhost ([127.0.0.1]:35933 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kZD7Z-0006B4-Ae
	for submit <at> debbugs.gnu.org; Sun, 01 Nov 2020 08:10:09 -0500
Received: from quimby.gnus.org ([95.216.78.240]:34092)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kZD7Y-0006Am-0T
 for 44100 <at> debbugs.gnu.org; Sun, 01 Nov 2020 08:10:08 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=vrLTv7WugCZ5l4TSheD1yiOB3yVjbSEXCVUbgpEYXqM=; b=siGGfp9k87cBj093t55VdVF9Wx
 HchhjGxkekCfTTXCg1NQT1mvRqD4YBT9nAyFBTNYMZRVSNFac/7v6J27OXkoSDwMWIGRpgC+Xj9Ek
 BCUgtF29nM0nDKtEvcWty5e7aCo2hTszLlNkvSFqS5t3dBAUpNhsDL8GQONXg2EX14Bg=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kZD7L-0000Hu-GS; Sun, 01 Nov 2020 14:10:01 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Amin Bandali <bandali@HIDDEN>
Subject: Re: bug#44100: Patch
References: <4578382.cRamKGfW39@ravel> <21986473.sr7ieKrsik@ravel>
 <CAJf-WoRBf-TNXSopiUnugOgAj_GAnJsRjkbuwBXRc-m4EB7-Jw@HIDDEN>
 <87imaquq6z.fsf@HIDDEN> <875z6pu8h5.fsf@HIDDEN>
X-Now-Playing: A Certain Ratio's _Loco_: "What's Wrong"
Date: Sun, 01 Nov 2020 14:09:54 +0100
In-Reply-To: <875z6pu8h5.fsf@HIDDEN> (Amin Bandali's message of "Sat, 31 Oct
 2020 22:16:54 -0400")
Message-ID: <87mu01cjfh.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview:  Amin Bandali <bandali@HIDDEN> writes: > However, I came up
 with a potentially more proper different fix: I think > the presence of the
 dotted pair with a non-nil cdr is the main problem,
 > since it means `erc-modified-channels-alist' does [...] 
 Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 44100
Cc: Corwin Brust <corwin@HIDDEN>, emacs-erc@HIDDEN, 44100 <at> debbugs.gnu.org,
 Olivier Certner <ocert.dev@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Amin Bandali <bandali@HIDDEN> writes:

> However, I came up with a potentially more proper different fix: I think
> the presence of the dotted pair with a non-nil cdr is the main problem,
> since it means `erc-modified-channels-alist' does not fully adhere to
> the documented structure in its docstring.  So I addressed the issue in
> `erc-track-modified-channels' by wrapping up single faces in lists too,
> ensuring that `erc-modified-channels-alist' never ends in a non-nil cdr.
>
> Something along the lines of the following patch.  Thoughts?

[...]

>    (when erc-face
>      (put-text-property 0 (length channame) 'face erc-face channame)
> -    (when (eq erc-face 'erc-default-face)
> +    (when (eq (car erc-face) 'erc-default-face)
>        (add-face-text-property 0 (length channame) 'bold t channame)))
>    channame)

Normalising to having a list of faces here sounds like a good idea, if
I'm skimming the code correctly, but it would probably help
comprehension a bit here if you renamed the parameter from `erc-face' to
something like `face-list'.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44100; Package emacs. Full text available.

Message received at 44100 <at> debbugs.gnu.org:


Received: (at 44100) by debbugs.gnu.org; 1 Nov 2020 02:17:06 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 31 22:17:06 2020
Received: from localhost ([127.0.0.1]:35167 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kZ2va-0008Kv-1j
	for submit <at> debbugs.gnu.org; Sat, 31 Oct 2020 22:17:06 -0400
Received: from eggs.gnu.org ([209.51.188.92]:58246)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bandali@HIDDEN>) id 1kZ2vW-0008KL-IT
 for 44100 <at> debbugs.gnu.org; Sat, 31 Oct 2020 22:17:05 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:47003)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <bandali@HIDDEN>)
 id 1kZ2vQ-0005nZ-CY; Sat, 31 Oct 2020 22:16:56 -0400
Received: from [2607:fea8:3fdf:f688:6557:fc41:50c6:42] (port=40338
 helo=localhost)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <bandali@HIDDEN>)
 id 1kZ2vP-0001PG-Tm; Sat, 31 Oct 2020 22:16:56 -0400
From: Amin Bandali <bandali@HIDDEN>
To: Corwin Brust <corwin@HIDDEN>
Subject: Re: bug#44100: Patch
Organization: GNU
References: <4578382.cRamKGfW39@ravel> <21986473.sr7ieKrsik@ravel>
 <CAJf-WoRBf-TNXSopiUnugOgAj_GAnJsRjkbuwBXRc-m4EB7-Jw@HIDDEN>
 <87imaquq6z.fsf@HIDDEN>
Date: Sat, 31 Oct 2020 22:16:54 -0400
In-Reply-To: <87imaquq6z.fsf@HIDDEN>
Message-ID: <875z6pu8h5.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="==-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 44100
Cc: emacs-erc@HIDDEN, 44100 <at> debbugs.gnu.org,
 Olivier Certner <ocert.dev@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--==-=-=
Content-Type: multipart/mixed; boundary="=-=-="

--=-=-=
Content-Type: text/plain

Hello again,

I did some more investigation, and was able to reproduce the issue.

However, I came up with a potentially more proper different fix: I think
the presence of the dotted pair with a non-nil cdr is the main problem,
since it means `erc-modified-channels-alist' does not fully adhere to
the documented structure in its docstring.  So I addressed the issue in
`erc-track-modified-channels' by wrapping up single faces in lists too,
ensuring that `erc-modified-channels-alist' never ends in a non-nil cdr.

Something along the lines of the following patch.  Thoughts?


--=-=-=
Content-Type: text/x-diff
Content-Disposition: inline;
 filename=0001-Maintain-the-documented-structure-for-erc-modified-c.patch
Content-Transfer-Encoding: quoted-printable

From=209cccb6b00fea837c9d28305db30b21353134b990 Mon Sep 17 00:00:00 2001
From: Amin Bandali <bandali@HIDDEN>
Date: Sat, 31 Oct 2020 21:41:38 -0400
Subject: [PATCH] Maintain the documented structure for
 'erc-modified-channels-alist'

* lisp/erc/erc-track.el (erc-track-modified-channels): Wrap the single
face in a list to avoid a non-nil final cdr in
`erc-modified-channels-alist', making its value adhere more closely to
its stated structure in its docstring.  Also unbreaks erc-ibuffer.
* lisp/erc/erc-status-sidebar.el (erc-status-sidebar-default-chan-format):
Account for the change in structure of `erc-modified-channels-alist'
due to this fix.
=2D--
 lisp/erc/erc-status-sidebar.el |  2 +-
 lisp/erc/erc-track.el          | 18 ++++++++++++------
 2 files changed, 13 insertions(+), 7 deletions(-)

diff --git a/lisp/erc/erc-status-sidebar.el b/lisp/erc/erc-status-sidebar.el
index 08dc8d6015..4fc9b4fc30 100644
=2D-- a/lisp/erc/erc-status-sidebar.el
+++ b/lisp/erc/erc-status-sidebar.el
@@ -191,7 +191,7 @@ erc-status-sidebar-default-chan-format
     (setq channame (format "%s [%d]" channame num-messages)))
   (when erc-face
     (put-text-property 0 (length channame) 'face erc-face channame)
=2D    (when (eq erc-face 'erc-default-face)
+    (when (eq (car erc-face) 'erc-default-face)
       (add-face-text-property 0 (length channame) 'bold t channame)))
   channame)
=20
diff --git a/lisp/erc/erc-track.el b/lisp/erc/erc-track.el
index 60f0cfa942..3618df6568 100644
=2D-- a/lisp/erc/erc-track.el
+++ b/lisp/erc/erc-track.el
@@ -815,10 +815,13 @@ erc-track-modified-channels
 			      (throw 'found t))))))
 	    (if (not (assq (current-buffer) erc-modified-channels-alist))
 		;; Add buffer, faces and counts
=2D		(setq erc-modified-channels-alist
=2D		      (cons (cons (current-buffer)
=2D				  (cons 1 (erc-track-find-face faces)))
=2D			    erc-modified-channels-alist))
+                (let ((new-face (erc-track-find-face faces)))
+                  (setq erc-modified-channels-alist
+                        (cons (cons (current-buffer)
+                                    (cons 1 (if (listp new-face)
+                                                new-face
+                                              (list new-face))))
+                              erc-modified-channels-alist)))
 	      ;; Else modify the face for the buffer, if necessary.
 	      (when faces
 		(let* ((cell (assq (current-buffer)
@@ -828,7 +831,10 @@ erc-track-modified-channels
 				  (if old-face
 				      (cons old-face faces)
 				    faces))))
=2D		  (setcdr cell (cons (1+ (cadr cell)) new-face)))))
+		  (setcdr cell (cons (1+ (cadr cell))
+                                     (if (listp new-face)
+                                         new-face
+                                       (list new-face)))))))
 	    ;; And display it
 	    (erc-modified-channels-display)))
       ;; Else if the active buffer is the current buffer, remove it
@@ -863,7 +869,7 @@ erc-track-last-non-erc-buffer
 `erc-track-switch-buffer'.")
=20
 (defun erc-track-sort-by-activest ()
=2D  "Sort erc-modified-channels-alist by activity.
+  "Sort `erc-modified-channels-alist' by activity.
 That means the number of unseen messages in a channel."
   (setq erc-modified-channels-alist
 	(sort erc-modified-channels-alist
=2D-=20
2.17.1


--=-=-=--

--==-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQJEBAEBCgAuFiEEObM8jZRIDS3cwqSYi0Sgzce5VvIFAl+eGpYQHGJhbmRhbGlA
Z251Lm9yZwAKCRCLRKDNx7lW8nt0D/wIAUelkBs1ph894KrnvO9zT8NP0Z0/qDEP
xl6y3fcSTnfSNZgjAhqlwBkbUsLDQjHKIfV5FgHdulW/75YcGdLrKzqOl3UmO5hR
xZIjRgSAdkPPY3+oyDreItumS9iK0hOz0xGE78JWGWUvU4JtbD8xECygXSabSn/k
GZcpPeoSdQKUFRJggtsqxvLu6fIWBz35Sb44Uh5xJYZ42CIXce8U4KhiLNuwOWMD
Hp1HCKtAfxPubzVB0R682xdlcNy34r+8VipqgwWlnnl33TJHk+IFP0wCLL0hs03B
6Y8hHCNewpIH6lSEZVIlpBYDHt7MathjrotJp5ayNkloSFG4lLsXZcmBL3RcoY8c
IqR1whWtWT6O1zqmqjvmY/3v1jZPFQX0ri6X/a4599vwyrL6qeyhpZ5uNAmgxN7K
Wdj0cQz0RPNe5PMyOaFfJcE7lhLvPkA6I058hT+1cfbRXPYYTitZbqtWgRRgxGiZ
Y3c6b7aKjdX1ciUPnugooeX3rZ0ViMsLeA4RPYYh19K2N7H6qfArb9WrP9xmp4U7
tXlKseT+8YJh2Nnq7sjLhlNPWKKmyz36enxMbCApQR0u/Ja0n1/ZIi3De8hZmTF0
EpYumv83LO36pPcolkIN3f+/ESRsZcOJ3glOWq2L2YcggBjsdxjMFjWTZEsHMRVi
aBhqHq1CIw==
=zaE8
-----END PGP SIGNATURE-----
--==-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44100; Package emacs. Full text available.

Message received at 44100 <at> debbugs.gnu.org:


Received: (at 44100) by debbugs.gnu.org; 31 Oct 2020 19:54:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Oct 31 15:54:24 2020
Received: from localhost ([127.0.0.1]:34597 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kYwxE-0004oe-1A
	for submit <at> debbugs.gnu.org; Sat, 31 Oct 2020 15:54:24 -0400
Received: from eggs.gnu.org ([209.51.188.92]:51652)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bandali@HIDDEN>) id 1kYwxB-0004oO-G1
 for 44100 <at> debbugs.gnu.org; Sat, 31 Oct 2020 15:54:22 -0400
Received: from fencepost.gnu.org ([2001:470:142:3::e]:42638)
 by eggs.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <bandali@HIDDEN>)
 id 1kYwx4-00045R-WD; Sat, 31 Oct 2020 15:54:15 -0400
Received: from [2607:fea8:3fdf:f688:6557:fc41:50c6:42] (port=39010
 helo=localhost)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <bandali@HIDDEN>)
 id 1kYwx4-00067h-KT; Sat, 31 Oct 2020 15:54:14 -0400
From: Amin Bandali <bandali@HIDDEN>
To: Corwin Brust <corwin@HIDDEN>
Subject: Re: bug#44100: Patch
Organization: GNU
References: <4578382.cRamKGfW39@ravel> <21986473.sr7ieKrsik@ravel>
 <CAJf-WoRBf-TNXSopiUnugOgAj_GAnJsRjkbuwBXRc-m4EB7-Jw@HIDDEN>
Date: Sat, 31 Oct 2020 15:54:12 -0400
In-Reply-To: <CAJf-WoRBf-TNXSopiUnugOgAj_GAnJsRjkbuwBXRc-m4EB7-Jw@HIDDEN>
Message-ID: <87imaquq6z.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha512; protocol="application/pgp-signature"
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 44100
Cc: emacs-erc@HIDDEN, 44100 <at> debbugs.gnu.org,
 Olivier Certner <ocert.dev@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

--=-=-=
Content-Type: text/plain

Hello Olivier, Corwin,

Corwin Brust writes:

> Thank you, Olivier!
>
> On Wed, Oct 21, 2020 at 6:42 AM Olivier Certner <ocert.dev@HIDDEN> wrote:
>>
>>         In attachment.
>>
>> --
>> Olivier Certner
>
> This looks fine to me.  Adding Amin and CC to the erc mailing list.
> TIA for review and comments!
>
> Regards,
> Corwin

Thanks for your Patch, Olivier; and thanks for the ping, Corwin.

I tried, but could not reproduce the error on Emacs trunk (from latest
git `master').  I will try with earlier versions, but it may be another
couple of days before I get to it.

Corwin, were you able to reproduce this?

Also, according to CONTRIBUTE [0] the ChangeLog files should not be
edited manually, and instead changes should be announced in the etc/NEWS
file, under the relevant section.

[0]: https://git.savannah.gnu.org/cgit/emacs.git/tree/CONTRIBUTE

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQJEBAEBCgAuFiEEObM8jZRIDS3cwqSYi0Sgzce5VvIFAl+dwOQQHGJhbmRhbGlA
Z251Lm9yZwAKCRCLRKDNx7lW8kEeD/9C/copUhEIJG4ptRSfMCwdrCkI/UXTVLfS
G2JM2pEATdyvgNkZ0t8xFfQ2X0PpAN9PFbsO5eGI9TKr/NjCMZQH1YxgDday6HNt
Ro4B0VLxZk4shAwbRPeIeNGOXL845agpZE+tpL5B444yZ3TGEYwQ15TLQeoQs58t
v/6XXfbN7sv8+dSb3iKdq42IzeGQB/w2sDYqag6cOTnuXxG1Lq9SqHudTXLSeTdC
C2378bysF0TC9Zbrod48DjVqxNdbtUUpM0gpo4oZtCsTCiugz8Hl4qmREu+rLK58
Wm/RQipGxTnl00cwbh0t1hikDnGG0V5Og75FvI9XGz0egmun02IhsCYfYBc2NZ+U
5eApEfJv8W353fO2DOAAUlReBeK9AzZPr+rVM5HMRfAzup0JvK8AQw9B29cy2ntG
Bbs9TBUbs3H2ZPuZk8vkp781izT3150EhsyYRkGlCyeO49NnQ/r47xGofrdey3Ch
Coi7YMuU6pwTea7ry75DEQ9Z5WO13Vs4C9Xc8QoqkaqbpNe66sUgHPvHgw1oXkTW
W+2aOHPyBUhGg0ncBQP+UdOutIpbvLU/BTt33SdLNRTo9oT5Y0PJNRC9s28sR4jc
p1UfQSCNr9V2rMRMEIq42vauVB+IE3uO4g/1Ze9RwjxIAY1cJigl9gSbH7iJlIqh
xY0gsrhubg==
=I04W
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44100; Package emacs. Full text available.
Added tag(s) patch. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 44100 <at> debbugs.gnu.org:


Received: (at 44100) by debbugs.gnu.org; 21 Oct 2020 15:54:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 21 11:54:34 2020
Received: from localhost ([127.0.0.1]:50310 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kVGRe-0005Qc-0L
	for submit <at> debbugs.gnu.org; Wed, 21 Oct 2020 11:54:34 -0400
Received: from mail-ej1-f49.google.com ([209.85.218.49]:42387)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mplscorwin@HIDDEN>) id 1kVGRc-0005QN-CB
 for 44100 <at> debbugs.gnu.org; Wed, 21 Oct 2020 11:54:33 -0400
Received: by mail-ej1-f49.google.com with SMTP id h24so3955421ejg.9
 for <44100 <at> debbugs.gnu.org>; Wed, 21 Oct 2020 08:54:32 -0700 (PDT)
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=ub5mAh9AF81O7cMRBpV/XL6R89/UY+GsOPWUrZ56FwE=;
 b=MG3V7VM6A0BjGbC5xBz6uD1d++/idJHHie01U4PKP9Kic1aaWGk5D8L0bWNFlfLqZj
 CmyxdLmP4Byo93u38+fQsP0CBnk8yl7WOGUpOT7aMm+XENAGzQHpNlAxTa+UddqKRs3U
 0GeEouN2FY/qkOsR+LUGV5Amxm5Wc/ofS1tYZbnHvehn5pMLi0GeqXq1SLHdMHroZIrL
 73P5bXsFZFNPATCj9XCJxp/eGd6XJf6MHhZw1aNVQX6caztUBPys7mBXfPl7MCMKHxMf
 N/xyL2ukQo0X0ja7E/9rqJ5sWo7lKf8Z2dJSmnKiJuvXL210l7vkvI4jlz/Pz0B654OG
 Ul6w==
X-Gm-Message-State: AOAM532nfj6RhoGi4ALKUlFUeTdrRm4IfOzND22dSo+B9DOZB/zWzI08
 rR/flc1L4iVu+RQGvg2u+g7IZZr7ho/1yNHmT/k=
X-Google-Smtp-Source: ABdhPJy7QT7uGxwftLqS7xCZBEljsmDdPO3u3BChCwE68JwA5AUZpCsL5k86m5rUXFQYaLjdYcn1CbPS0Mvqg+IQYzY=
X-Received: by 2002:a17:906:489b:: with SMTP id
 v27mr4360200ejq.315.1603295665379; 
 Wed, 21 Oct 2020 08:54:25 -0700 (PDT)
MIME-Version: 1.0
References: <4578382.cRamKGfW39@ravel> <21986473.sr7ieKrsik@ravel>
In-Reply-To: <21986473.sr7ieKrsik@ravel>
From: Corwin Brust <corwin@HIDDEN>
Date: Wed, 21 Oct 2020 10:54:13 -0500
Message-ID: <CAJf-WoRBf-TNXSopiUnugOgAj_GAnJsRjkbuwBXRc-m4EB7-Jw@HIDDEN>
Subject: Re: bug#44100: Patch
To: Olivier Certner <ocert.dev@HIDDEN>, Amin Bandali <bandali@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.5 (/)
X-Debbugs-Envelope-To: 44100
Cc: emacs-erc@HIDDEN, 44100 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.5 (/)

Thank you, Olivier!

On Wed, Oct 21, 2020 at 6:42 AM Olivier Certner <ocert.dev@HIDDEN> wrote:
>
>         In attachment.
>
> --
> Olivier Certner

This looks fine to me.  Adding Amin and CC to the erc mailing list.
TIA for review and comments!

Regards,
Corwin




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44100; Package emacs. Full text available.

Message received at 44100 <at> debbugs.gnu.org:


Received: (at 44100) by debbugs.gnu.org; 21 Oct 2020 11:37:04 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 21 07:37:04 2020
Received: from localhost ([127.0.0.1]:48173 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kVCQR-0002fI-VV
	for submit <at> debbugs.gnu.org; Wed, 21 Oct 2020 07:37:04 -0400
Received: from smtp2-g21.free.fr ([212.27.42.2]:31117)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ocert.dev@HIDDEN>) id 1kVB34-0006Xh-Ss
 for 44100 <at> debbugs.gnu.org; Wed, 21 Oct 2020 06:08:51 -0400
Received: from ravel.localnet (unknown [2.15.200.177])
 (Authenticated sender: ocert.dev@HIDDEN)
 by smtp2-g21.free.fr (Postfix) with ESMTPSA id 92E1D200348
 for <44100 <at> debbugs.gnu.org>; Wed, 21 Oct 2020 12:08:48 +0200 (CEST)
From: Olivier Certner <ocert.dev@HIDDEN>
To: 44100 <at> debbugs.gnu.org
Subject: Patch
Date: Wed, 21 Oct 2020 12:08:47 +0200
Message-ID: <21986473.sr7ieKrsik@ravel>
MIME-Version: 1.0
Content-Type: multipart/mixed; boundary="nextPart3302483.j5jfTYeP2b"
Content-Transfer-Encoding: 7Bit
X-Spam-Score: 2.0 (++)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 Content preview: In attachment. -- Olivier Certner From
 33586f449fdf646fbfb1aa6bd5ef6ca4c4848761
 Mon Sep 17 00:00:00 2001 From: Olivier Certner Date: Tue, 20 Oct 2020 18:36:25
 +0200 Subject: [PATCH] ERC: Make IBuffer ERC's custom [...] 
 Content analysis details:   (2.0 points, 10.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 0.0 SPF_NONE               SPF: sender does not publish an SPF Record
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at https://www.dnswl.org/,
 no trust [212.27.42.2 listed in list.dnswl.org]
 0.0 RCVD_IN_MSPIKE_H3      RBL: Good reputation (+3)
 [212.27.42.2 listed in wl.mailspike.net]
 0.0 SPF_HELO_NONE          SPF: HELO does not publish an SPF Record
 0.0 FREEMAIL_FROM          Sender email is commonly abused enduser mail
 provider (ocert.dev[at]free.fr)
 0.0 RCVD_IN_MSPIKE_WL      Mailspike good senders
 2.0 SPOOFED_FREEMAIL       No description available.
X-Debbugs-Envelope-To: 44100
X-Mailman-Approved-At: Wed, 21 Oct 2020 07:37:02 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

This is a multi-part message in MIME format.

--nextPart3302483.j5jfTYeP2b
Content-Transfer-Encoding: 7Bit
Content-Type: text/plain; charset="UTF-8"

	In attachment.

-- 
Olivier Certner
--nextPart3302483.j5jfTYeP2b
Content-Disposition: attachment; filename="0001-ERC-Make-IBuffer-ERC-s-custom-displays-work-again.patch"
Content-Transfer-Encoding: 7Bit
Content-Type: text/x-patch; charset="UTF-8"; name="0001-ERC-Make-IBuffer-ERC-s-custom-displays-work-again.patch"

From 33586f449fdf646fbfb1aa6bd5ef6ca4c4848761 Mon Sep 17 00:00:00 2001
From: Olivier Certner <ocert.dev@HIDDEN>
Date: Tue, 20 Oct 2020 18:36:25 +0200
Subject: [PATCH] ERC: Make IBuffer ERC's custom displays work again

* lisp/erc/erc-ibuffer.el (erc-modified): Don't use `length' on
dotted lists (and not even to test if there is more than one
element, for that matter). Use `cdr' instead.
---
 ChangeLog.3             | 8 ++++++++
 lisp/erc/erc-ibuffer.el | 2 +-
 2 files changed, 9 insertions(+), 1 deletion(-)

diff --git a/ChangeLog.3 b/ChangeLog.3
index ec2d3f8d46..86579b3913 100644
--- a/ChangeLog.3
+++ b/ChangeLog.3
@@ -1,3 +1,11 @@
+2020-10-20  Olivier Certner  <ocert.dev@HIDDEN>
+
+	ERC: Make IBuffer ERC's custom displays work again
+
+	* lisp/erc/erc-ibuffer.el (erc-modified): Don't use `length' on
+	dotted lists (and not even to test if there is more than one
+	element, for that matter). Use `cdr' instead.
+
 2020-08-03  Phil Sainty  <psainty@HIDDEN>
 
 	lisp/so-long.el: Improve support for major mode hooks
diff --git a/lisp/erc/erc-ibuffer.el b/lisp/erc/erc-ibuffer.el
index 7aee7705ff..955b022177 100644
--- a/lisp/erc/erc-ibuffer.el
+++ b/lisp/erc/erc-ibuffer.el
@@ -77,7 +77,7 @@
 	   erc-track-mode)
       (let ((entry (assq (current-buffer) erc-modified-channels-alist)))
 	(if entry
-	    (if (> (length entry) 1)
+	    (if (cdr entry)
 		(cond ((eq 'pal (nth 1 entry))
 		       (string erc-ibuffer-pal-char))
 		      ((eq 'fool (nth 1 entry))
-- 
2.24.1


--nextPart3302483.j5jfTYeP2b--







Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44100; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 20 Oct 2020 16:48:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Oct 20 12:48:07 2020
Received: from localhost ([127.0.0.1]:46589 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kUunv-0000ZV-25
	for submit <at> debbugs.gnu.org; Tue, 20 Oct 2020 12:48:07 -0400
Received: from lists.gnu.org ([209.51.188.17]:59132)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ocert.dev@HIDDEN>) id 1kUufT-0006gx-S9
 for submit <at> debbugs.gnu.org; Tue, 20 Oct 2020 12:39:24 -0400
Received: from eggs.gnu.org ([2001:470:142:3::10]:49802)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ocert.dev@HIDDEN>) id 1kUufT-0000g3-J6
 for bug-gnu-emacs@HIDDEN; Tue, 20 Oct 2020 12:39:23 -0400
Received: from smtp2-g21.free.fr ([2a01:e0c:1:1599::11]:57700)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <ocert.dev@HIDDEN>) id 1kUufR-0001DF-NR
 for bug-gnu-emacs@HIDDEN; Tue, 20 Oct 2020 12:39:23 -0400
Received: from ravel.localnet (unknown [2.15.200.177])
 (Authenticated sender: ocert.dev@HIDDEN)
 by smtp2-g21.free.fr (Postfix) with ESMTPSA id 85F21200430
 for <bug-gnu-emacs@HIDDEN>; Tue, 20 Oct 2020 18:39:16 +0200 (CEST)
From: Olivier Certner <ocert.dev@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: 26.3; ERC: Make IBuffer custom display work again
Date: Tue, 20 Oct 2020 18:39:15 +0200
Message-ID: <4578382.cRamKGfW39@ravel>
MIME-Version: 1.0
Content-Transfer-Encoding: 7Bit
Content-Type: text/plain; charset="UTF-8"
Received-SPF: none client-ip=2a01:e0c:1:1599::11;
 envelope-from=ocert.dev@HIDDEN; helo=smtp2-g21.free.fr
X-detected-operating-system: by eggs.gnu.org: No matching host in p0f cache.
 That's all we know.
X-Spam_score_int: 1
X-Spam_score: 0.1
X-Spam_bar: /
X-Spam_report: (0.1 / 5.0 requ) BAYES_00=-1.9, FREEMAIL_FROM=0.001,
 SPF_HELO_NONE=0.001, SPF_NONE=0.001,
 SPOOFED_FREEMAIL=1.987 autolearn=no autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -0.3 (/)
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Tue, 20 Oct 2020 12:48:05 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Applies to 26.3, but also all more recent versions as well.

Bug trigger:
1. Load ERC (e.g., open some IRC connection).
2. Launch ibuffer (e.g., type "M-x ibuffer").
3. Switch formats three times (e.g., type "`" three times).
4. You get this error: (wrong-type-argument listp erc-notice-face) and
the buffer is only partly filled, and then cannot be updated.

Root cause:
erc-ibuffer assumes (in (define-ibuffer-column erc-modified ...) form)
that erc-modified-channels-alist is an alist whose values are proper
lists, whereas they are dotted lists.

Patch:
To be attached shortly after bug creation.

-- 
Olivier Certner






Acknowledgement sent to Olivier Certner <ocert.dev@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#44100; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Sun, 1 Nov 2020 13:15:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.